#!/bin/bash
 
#SBATCH -n 1
#SBATCH -t 120:00:00
#SBATCH -J oras4_O1L46
#SBATCH --mail-user <chloe.prodhomme@ic3.cat>
#SBATCH --mail-type FAIL
#SBATCH -o oras4_O1L46-%j.out
#SBATCH -e oras4_O1L46-%j.err

set -evx

year0=
yearf=
fc0=1
fcf=4
lstMM=(  )
config='O1L46'
TMPDIR=
SHAREDDIR=/shared/earth/software/scripts/prep_restarts
#mkdir $TMPDIR
cd $TMPDIR
cp ${SHAREDDIR}/library/comp_rhop_$config comp_rhop
cp ~/tools/cfutools/prep_restarts/script_interp_vert_ocean_restart.bash .
for ((year=${year0};year<=${yearf};year++)) ; do
 for ((fc=${fc0};fc<=${fcf};fc++)) ; do
  for MM in ${lstMM[@]} ; do
   cp /esnas/releases/ic/ocean/ORCA1/s4/s4_fc${fc}_${year}${MM}_restart.nc.gz .
   gunzip s4_fc${fc}_${year}${MM}_restart.nc.gz
   # Vertical interpolation + horizontal and vertical extrapolation + filling empty seas 
   #mask to generate the tofill files
   #cdo mulc,0 /esnas/autosubmit/con_files/mesh_mask_nemo.Ec3.2_O1L75.nc tofill.nc

   bash script_interp_vert_ocean_restart.bash s4_fc${fc}_${year}${MM}_restart s4_fc${fc}_${year}${MM}_restart_${config} ${MM:0:2} ${config/O/ORCA} /esnas/autosubmit/con_files/mesh_mask_nemo.Ec3.2_O1L75.nc ${SHAREDDIR}/auxfiles/masks/Tofill_ecearth.v3.2.ORCA1L75.extrap.oras4.restarts.nc ${SHAREDDIR}/auxfiles/masks/Tofill_ecearth.v3.2.ORCA1L75.clim.nc
   # rhop needs to be added for EC-Earth3 ; computed from tn and sn
   cat > namelist_rhop <<EOF
&density
  input_file = 's4_fc${fc}_${year}${MM}_restart_${config}.nc'
  input_Tvar = 'tn'
  input_Svar = 'sn'
  input_Dvar = 'nav_lev'
  outfile    = 'rhop_fc${fc}_${year}${MM}.nc'
/
EOF
   ./comp_rhop
   ncwa -O -a t rhop_fc${fc}_${year}${MM}.nc rhop_fc${fc}_${year}${MM}.nc
   ncks -A rhop_fc${fc}_${year}${MM}.nc s4_fc${fc}_${year}${MM}_restart_${config}.nc
   # The output restart is masked to be able to check the mask
   # but EC-Earth does not accept masks
   cdo setmisstoc,0 s4_fc${fc}_${year}${MM}_restart_${config}.nc tmp.nc; rm -f s4_fc${fc}_${year}${MM}_restart_${config}.nc; mv tmp.nc s4_fc${fc}_${year}${MM}_restart_${config}.nc 
   # Storage
   gzip s4_fc${fc}_${year}${MM}_restart_${config}.nc
   mv s4_fc${fc}_${year}${MM}_restart_${config}.nc.gz /esnas/releases/ic/ocean/ORCA${config/O/}/s4/s4_fc${fc}_${year}${MM}_restart.nc.gz
   rm -f s4_fc${fc}_${year}${MM}_restart.nc namelist_rhop rhop_fc${fc}_${year}${MM}.nc
  done
 done
done
rm -f comp_rhop script_interp_vert_ocean_restart.bash
rm -rf $TMPDIR
